# variables (secrets):
# GITLAB_TOKEN - personal access token
# GOOGLE_CLOUD_ACCOUNT - json key
# SLACK_WEBHOOK - webhook url
# variables inside script:
# GITLAB_IMAGE - gitlab registry url
# GCR_IMAGE - google container registry url


workflow:
  rules:
    - if: '$CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_REF_NAME == "release"'
      when: always
    - if: '$CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_REF_NAME == "main"'
      when: always
    - if: '$CI_PIPELINE_SOURCE == "push" && $CI_COMMIT_BRANCH == "dev"'
      when: always
    - if: '$CI_COMMIT_TAG =~ /rc-[0-9]/ || $CI_COMMIT_TAG =~ /v[0-9]\.[0-9]\.[0-9]/'
      when: always
    - when: never

#image: docker:git

# services:
#   - docker:dind

stages:
  - image-tag
  - build
  - git-tag
  - publish

variables:
  GITLAB_IMAGE: registry.gitlab.com/t.artiushenko/test
  GCR_IMAGE: eu.gcr.io/valid-volt-331607/test-gitlab

include:
  - local: '.gitlab-ci/image-tag-job.yml'
  - local: '.gitlab-ci/build-job.yml'
  - local: '.gitlab-ci/git-tag-job.yml'
    rules:
     - if: '$CI_COMMIT_REF_NAME == "main" || $CI_COMMIT_REF_NAME == "release"'
  - local: '.gitlab-ci/publish-job.yml'
